routes/web.php
<?php

use App\Http\Controllers\ArticleController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ChangePasswordController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\LikeController;
use App\Http\Controllers\PageController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\TagController;
use App\Http\Controllers\UserController;
use App\Models\Article;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

# Home
Route::get('/', HomeController::class)->name('home');

// # Users
Route::get('/users', [UserController::class, 'index'])->name('users.index');
Route::get('/users/{user}', [UserController::class, 'show'])->name('users.show');

# Approvement
Route::controller(ArticleController::class)->middleware('can.write.article')->group(function() {
    # Table
    Route::get('articles/table', [ArticleController::class, 'table'])->name('articles.table');
    # Update Status
    Route::put('articles/{article}/update-status', [ArticleController::class, 'updateStatus'])->name('articles.update-status');
});


# Article Search
Route::get('articles/search', [ArticleController::class, 'search'])->name('articles.search');

# Articles
Route::resource('articles', ArticleController::class);

# Category
Route::resource('categories', CategoryController::class);

# Tags
Route::resource('tags', TagController::class);


Route::middleware('auth')->group(function() {
    # Comments
    Route::controller(CommentController::class)->group(function () {
        Route::post('comments/{article}', 'store')->name('comments.store');
        Route::delete('comments/{comment}', 'destroy')->name('comments.destroy');
    });
    # Likes
    Route::controller(LikeController::class)->group(function() {
        Route::post('like-comment/{comment}', 'likeComment')->name('comments.like');
        Route::post('like-article/{article}', 'likeArticle')->name('articles.like');
    });
});


# Auth
require __DIR__ . '/auth.php';

Route::controller(RoleController::class)->middleware('only.admin')->group(function () {
    Route::post('roles/assign/{user}', 'assign')->name('roles.assign');
});

# Account
Route::controller(UserController::class)->group(function() {
    Route::get('users', 'index')->name('users.index');
    Route::get('/account/edit', 'edit')->name('users.edit');
    Route::put('/account/edit', 'update')->name('users.update');
    Route::get('/{user}', [UserController::class, 'show'])->name('users.show');
});

# Change Password
Route::controller(ChangePasswordController::class)->middleware('auth')->group(function () {
    Route::get('account/password-edit', 'edit')->name('change-password.edit');
    Route::put('account/password-edit', 'update')->name('change-password.update');
});

// # Users
Route::get('/{user}', [UserController::class, 'show'])->name('user.show');

app/Models/Tag.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Tag extends Model
{
    use HasFactory;
    protected $fillable = ['name', 'slug'];

    # get route key name
    public function getRouteKeyName()
    {
        return 'slug';
    }

    # published article
    public function scopePublished($query)
    {
        return $query->where('status', \App\Enums\ArticleStatus::PUBLISHED);
    }

    # relation table
    public function articles()
    {
        return $this->belongsToMany(Article::class);
    }
}

app/Http/Controllers/TagController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\TagRequest;
use App\Models\Tag;

class TagController extends Controller
{
    # method __construct for middleware
    public function __construct()
    {
        return $this->middleware(['only.admin', 'auth', 'verified', 'preventBackHistory'])->except('show');
    }

    # show all data tags
    public function index()
    {
        # action show all data tags
        $tags = Tag::select('name', 'slug')->latest()->paginate(10);

        # return view
        return view('tags.index', compact('tags'));
    }

    # view create tag
    public function create()
    {
        $tag = new Tag();
        # return view
        return view('tags.create', compact('tag'));
    }

    # process create tag
    public function store(TagRequest $request)
    {
        # action create tag
        Tag::create([
            'name' => $name = $request->name,
            'slug' => str($name . ' ' . str()->random(3))->slug(),
        ]);
        return to_route('tags.index')->with('success', 'Data tag has been created ');
    }

    # show articles by tag
    public function show(Tag $tag)
    {
        # action get articles by tag
        $articles = $tag->articles()->published()->paginate(15);

        # return view
        return view('tags.show', compact('tag', 'articles'));
    }

    # view edit tag
    public function edit(Tag $tag)
    {
        return view('tags.edit', compact('tag'));
    }

    # process update tag
    public function update(TagRequest $request, Tag $tag)
    {
        # action update tag
        $tag->update([
            'name' => $name = $request->name,
            'slug' => str($name . ' ' . str()->random(3))->slug(),
        ]);

        # redirect
        return to_route('tags.index')->with('success', 'Data tag has been updated ');
    }

    # process delete tag
    public function destroy(Tag $tag)
    {
        # action delete tag
        $tag->delete();

        # redirect
        return to_route('tags.index')->with('success', 'Data tag has been deleted ');
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use App\Enums\ArticleStatus;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\View\Component;

class AppLayout extends Component
{
    public $title;
    /**
     * Create a new component instance.
     *
     * @return void
     */

    public function __construct($title = 'Default Title')
    {
        $this->title = $title;
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        $categories = \App\Models\Category::query()
        ->select('name', 'slug')
        ->whereHas('articles', function(Builder $query) {
            $query->where('status', ArticleStatus::PUBLISHED);
        })
        ->get();
        return view('layouts.app', compact('categories'));
    }
}

resources/views/tags/create.blade.php
<x-app-layout title="Create New Tag - GreenK Article">
  <div class="container">
    <div class="row">
      <div class="col-md-8">
        <x-card title="New" subtitle="Create new tag" class="shadow">
            {{-- form create tag --}}
          <form action="{{ route('tags.store') }}" method="POST">
            @include('tags.form', ['submit' => 'Create'])
          </form>
        </x-card>
      </div>

      {{-- table of tags --}}
      <div class="col-md-4">
        <a class="btn btn-primary w-100" href="{{ route('tags.index') }}">
          Table of tags
        </a>
      </div>
    </div>
  </div>
</x-app-layout>

resources/views/tags/edit.blade.php
<x-app-layout title="Edit tag {{ $tag->name }} - GreenK Article">
  <div class="container">
    <div class="row">
      <div class="col-md-8">
        <x-card title="Edit" class="shadow">
          {{-- Form Edit Tag --}}
          <form action="{{ route('tags.update', $tag) }}" method="POST">
            @method('PUT')
            @include('tags.form', ['submit' => 'Update'])
          </form>
        </x-card>
      </div>
      <div class="col-md-4">
        {{-- Table of Tags --}}
        <a class="btn btn-primary w-100" href="{{ route('tags.index') }}">
          Table of tags
        </a>

        {{-- Button Delete Modal --}}
        <button type="button" class="btn btn-danger w-100 mt-2" data-bs-toggle="modal" data-bs-target="#exampleModal">
          Delete
        </button>
        <div class="modal fade" id="exampleModal" tabindex="-1" arialabelledby="exampleModalLabel" aria-hidden="true">
          <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
              <div class="modal-header">
                <div class="modal-title" id="exampleModalLabel">Tag: {{ $tag->name }}</div>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
              </div>
              <div class="modal-body">
                <p class="text-muted text-center">Are you really sure you want to
                  delete it?</p>
                <div class="d-flex align-items-center gap-2 justify-content-center">
                  {{-- Form Delete Tag --}}
                  <form action="{{ route('tags.destroy', $tag) }}" method="POST">
                    @csrf
                    @method('DELETE')
                    {{-- Submit Button Delete --}}
                    <button type="submit" class="btn btn-danger">
                      Yes
                    </button>
                  </form>
                  <button type="button" class="btn btn-secondary" data-bsdismiss="modal" aria-label="Close">No</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</x-app-layout>

resources/views/tags/form.blade.php
@csrf
<div class="mb-4">
  {{-- Tag Name --}}
  <label for="name" class="form-label">Tag Name</label>
  <input type="text" name="name" id="name" class="form-control @error('name') is-invalid @enderror" value="{{ old('name', $tag->name) }}">
  @error('name')
  <div class="invalid-feedback">{{ $message }}</div>
  @enderror
</div>
{{-- Button Submit --}}
<button type="submit" class="btn btn-primary">{{ $submit }}</button>

resources/views/tags/index.blade.php
<x-app-layout title="Tags - GreenK Article">
  @push('styles')
  @include('components.toast.alerts-css')
  @endpush
  <div class="container">
    <div class="row">
      <div class="d-flex align-items-center justify-content-center">
        <div class="col-md-8">
          <div class="d-flex justify-content-end mb-2">
            <a class="btn btn-primary" href="{{ route('tags.create') }}">New</a>
          </div>
          <x-card title="Tags" subtitle="Table of tags" class="shadow">
            <div class="table-responsive">

              {{-- table of tags --}}
              <table class="table">
                <thead>
                  <tr>
                    <th>#</th>
                    <th>Name</th>
                    <th>Slug</th>
                    <th>Action</th>
                  </tr>
                </thead>
                <tbody>
                  @forelse ($tags as $index => $tag)
                  <tr>
                    <td>{{ $index + 1 }}</td>
                    <td>{{ $tag->name }}</td>
                    <td>{{ $tag->slug }}</td>
                    <td>
                      <a href="{{ route('tags.edit', $tag) }}" class="btn btn-warning btn-sm">
                        Edit
                      </a>
                    </td>
                  </tr>
                  @empty
                  <tr>
                    <td colspan="4" class="alert alert-info">No Tag Data</td>
                  </tr>
                  @endforelse
                </tbody>
              </table>

            </div>
          </x-card>
          {{-- pagination --}}
          {{ $tags->links() }}
        </div>
      </div>
    </div>
  </div>
  @push('scripts')
  @include('components.toast.alerts-js')
  @endpush
</x-app-layout>

resources/views/tags/show.blade.php
<x-app-layout title="{{ $tag->name }} Tag - GreenK Article">
    <x-header title="{{ $tag->name }}" subtitle="This page will show all articles tagged by {{ $tag->name }}" />
    <div class="container">
        <x-articles :articles="$articles" />
    </div>
</x-app-layout>